# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Apr-11 23:06 (EDT)
# Function: example service test
#
# $Id: Example.pm,v 1.3 2002/10/20 22:32:13 jaw Exp $

package Example;
@ISA = qw(Service BaseIO MonEl);

$doc = {
    package => __PACKAGE__,
    file    => __FILE__,
    isa     => [@ISA],
    methods => {
	# ...
    },
    fields => {
	# ...
    },
};

sub probe {
    my $name = shift;

    return ( $name =~ /^Example/ ) ? \&config : undef;
}

sub config {
    my $me = shift;
    my $cf = shift;

    $me->init_from_config( $doc, 'example' );

    # ...
    
    bless $me, 'Example';
    $me;
}

sub start {
    my $me = shift;
    my( $fh, $i, $to );

    $me->debug( "Example Start: ..." );

    $me->{fd} = $fh = BaseIO::anon_fh();

    # open( $fh, ...
    $me->baseio_init();
    $me->Service::start();

    # ...

    $me->wantread(0);
    $me->wantwrit(1);
    $me->settimeout( $me->{srvc}{timeout} );
}

sub timeout {
    my $me = shift;

    $me->debug( "timeout" );
    
    $me->isdown( "Example timeout" );
}

sub writable {
    my $me = shift;

    # ...
}

sub readable {
    my $me = shift;

    # ...

    if( ){
	$me->isup();
    }else{
	$me->isdown();
    }
}

sub done {
    my $me = shift;

    $me->debug( "done" );
    $me->shutdown();
    $me->Service::done();
}


################################################################
# global config
################################################################
Doc::register( $doc );
push @Service::probes, \&probe;

1;
